g_dinamic_cssjs.push("jusaas/js/UniCommonObject.js");

/*
根据MCSS模型从后台获取的记录数组的处理类
规则：
保存到数据库后，newData清空
*/
function MCSSData(data,modeldata,params)
{
	if (!params)
		params={};
	if (!data)
		return;
	this.params=params;
	this.modeldata=modeldata;//mcss模型结构

	this.initData=data;//初始数据
	this.instance_id=getTimeId();//类实例生成的id
	this.data=copyArray(data);//完全数据,包括初始数据和修改过、新增的数据
	this.datas={};//把所有记录转化为以记录id为key的json对象，这样定位快
	
	this.newData=new Array();//新添或修改或删除的数据
	
	this.activecellFieldId='activecell';
	this.keyfield='id';
	if (!this.modeldata)
		return;
	if (this.modeldata.keyfield)
		this.keyfield=this.modeldata.keyfield;
	
	this.homeUrl=g_homeurl;
	this.state="";
	this.inputedByKey=false;//是否有键盘输入且未保存
	this.initialize=function()
	{
		for(var i=0;i<this.data.length;i++)
		{
			this.datas[this.data[i][this.keyfield]]=this.data[i];
		}	
	}

	//recordid：记录关键字段值。如果是数字，则表示记录序号
	this.getRow=function(recordid)
	{
		if (!recordid)
			return null;
		if (typeof(recordid)==='number')
			return this.data[recordid];
		
		for(var i=0;i<this.data.length;i++)
		{
			if (this.data[i][this.keyfield]==recordid || this.data[i].mcss_recordid==recordid)
				return this.data[i];
		}
	}
	//根据记录id获得所在行的第几行
	this.getRowIndex=function(recordid)
	{
		for(var i=0;i<this.data.length;i++)
		{
			if (this.data[i][this.keyfield]==recordid || this.data[i].mcss_recordid==recordid)
				return i;
		}	
		return -1;
	}
	//根据记录id获得其顺序号。recordid：记录关键字段值
	this.getRowIndex=function(recordid)
	{
		for(var i=0;i<this.data.length;i++)
		{
			if (this.data[i][this.keyfield]==recordid)
				return i;
		}
	}

	//更新最初数据中的某记录的某字段的值
	this.getFieldOldValue=function(recordid,fieldid)
	{
		for(var i=0;i<this.initData.length;i++)
		{
			if (this.initData[i][this.keyfield]==recordid)
				return this.initData[i][fieldid];
		}
		return null;
	}
	//更新最初数据的某字段的值
	this.setFieldOldValue=function(recordid,fieldid,value)
	{
		for(var i=0;i<this.initData.length;i++)
		{
			if (this.initData[i][this.keyfield]==recordid)
				this.initData[i][fieldid]=value;
		}
	}

	//获得更新过并已经保存到this.data字段的值
	this.getFieldUpdatedValue=function(recordid,fieldid)
	{
		for(var i=0;i<this.data.length;i++)
		{
			if (this.data[i][this.keyfield]==recordid)
				return this.data[i][fieldid];
		}
		return null;
	}
	//从最新数据中，获得某记录的某字段的值
	this.getFieldValue=function(recordid,fieldid)
	{
		var row=this.getRow(recordid);
		if (row)
			return row[fieldid];
		
	}

	//编辑完全数据组this.data中的数据
	this.setFieldValue=function(recordid,fieldid,value)
	{
		var row=this.getRow(recordid);
		if (row)
		{
			if (row[fieldid]!=value){
				this.updateNewData({mcss_recordtype:'UPDATE',recordid:recordid,fieldid:fieldid,value:value});
			}
			row[fieldid]=value;
			this.state="CHANGED";
			if (this.params.afterDataChanged)
				this.params.afterDataChanged(this,recordid);			
		}
		
	}
	//把新记录更新到data属性
	this.updateRow=function(recordid,newrow)
	{
		var oldrow=this.getRow(recordid);
		for(f in newrow)
		{
			if (f)
			oldrow[f]=newrow[f];
		}
	}
	//把新数据单元（单记录但字段的值）更新到newData和data	
	this.updateNewData=function(record)
	{
		var found=false;
		for(var i=0;i<this.newData.length;i++)
		{
			if (this.newData[i].mcss_recordid==record.recordid || this.newData[i][this.keyfield]==record.recordid)
			{
				this.newData[i][record.fieldid]=record.value;
				found=true;
				break;
			}
		}
		if (!found)
		{
			var data={mcss_recordtype:record.mcss_recordtype,mcss_recordid:record.recordid};
			if (record.fieldid)
				data[record.fieldid]=record.value;
			this.newData.push(data);			
		}
		this.state="CHANGED";				
		if (this.params.afterDataChanged)
			this.params.afterDataChanged(this,record);
		
		
		//上面更新了“更新数据”，下面同时要更新总数据data属性，不用更新原始数据变量initdata
		var row=this.getRow(record.recordid);
		if (row)
		{
			row[record.fieldid]=record.value;
			found=true;
		}
		if (!row)
		{
			var data={mcss_recordtype:record.mcss_recordtype,mcss_recordid:record.recordid};
			if (record.fieldid)
				data[record.fieldid]=record.value;
			this.data.push(data);
			this.state="CHANGED";			
			if (this.params.afterDataChanged)
				this.params.afterDataChanged(this,record);
		}
	}
//add by sunliangchao
	//直接从data列表中去除一行，什么都不做，在懒加载时使用
	this.unloadRow=function(recordid)
	{
		var r=this.getRowIndex(recordid);
		if (r>-1){
			this.data.splice(r,1);
		}
	}
	//add by sunliangchao
	//加载更多数据，在懒加载时使用。
	this.loadMoreRows=function(newRows)
	{
		var rows=copyArray(newRows);
		
		for(var i = 0;i < rows.length;i++){
			this.data.push(rows[i]);
		}
		this.initialize();
	}
	/*
	更新一条记录一个字段的值. editNewData与setFieldValue作用类似，只是参数不同
	record.recordid:记录id
	record.mcss_recordtype:更新类型，可取NEW/DELETE/UPDATE
	record.fieldid:字段id
	record.value:字段值
	*/
	this.editNewData=function(record)
	{
		var row=this.getRow(record.recordid);
		if (row)
			row[record.fieldid]=record.value;
		this.updateNewData(record);		
	}
	//解析是否可编辑条件
	this.canEditRecord=function(record)
	{
		if (!this.modeldata.editcondition)
			return true;
		
		var FieldArr=this.modeldata.fields;
		var editcondition = this.modeldata.editcondition;
		for (var i=0;i<FieldArr.length;i++)
		{ 			
			var reg = new RegExp("\\["+FieldArr[i]["id"]+"\\]","gi");
			editcondition = editcondition.replace(reg,"'"+record[FieldArr[i].id]+"'");
		}	
		try{
			if (editcondition!==null && eval(editcondition)==false)
				return false;
		}
		catch(e){
			alert(lang.analyticexpression+"("+editcondition+")"+lang.error+"。"+lang.originalinformation+"："+e.message);
		}
		return true;
	}

	this.appendRow=function(record)
	{
		this.data.push(record);
		this.state="CHANGED";		
	}

	this.currentSearchedRecordid=null;
	this.searchNext=function(text)
	{
	}
	

	//删除原有的记录，或刚刚添加的记录	
	this.deleteRow=function(record)
	{
		var found=false;
		for(var i=0;i<this.newData.length;i++)
		{
			if (this.newData[i].mcss_recordid==record.recordid)
			{
				if (this.newData[i].mcss_recordtype=="NEW")
					this.newData[i].mcss_recordtype="";//mcss_recordtype为空，在保存前会被忽略掉不会传到后台
				else
					this.newData[i].mcss_recordtype="DELETE";
				found=true;
				break;
			}
		}
		if (!found)
		{
			var data={mcss_recordtype:"DELETE",mcss_recordid:record.recordid};
			this.newData.push(data);
			this.state="CHANGED";
		}
		if (record.recordid)
		{
			if (this.params.afterDeleteRow)
				this.params.afterDeleteRow(this,record);
			if (this.params.afterDataChanged)
				this.params.afterDataChanged(this,record);
			for(var i = 0;i < this.data.length;i++){
				for(var value in this.data[i]){
					if(this.data[i][value]==record.recordid){
						this.data.splice(i,1);
						return;
					}
				}
			}	
		}
	}
	//获得指定字段的不重复的值
	this.getFieldValueEnum=function(fieldid)
	{
		var arr=new Array();
		for(var i=0;i<this.data.length;i++)
		{
			var found=false;
			for(ii=0;ii<arr.length;ii++)
			{
				if(arr[ii] == this.data[i][fieldid])
				{
					found=true;
					break;
				}
			}
			if (!found)
				arr.push(this.data[i][fieldid]);
		}
		return arr;
	}
	//add by sunliangchao
	//从数据库中取得一个值内容
	this.getDBValue=function(projectid,recordid,fieldid,callback)
	{
		var urlpath =this.homeUrl+g_systempath+"/getDBValue";
		var saveRecordTag = 'web';
		$.post(
			urlpath, 
			{projectid:projectid,modelid:this.modeldata.id,recordid:recordid,fieldid:fieldid},
			function(data){
				callback(recordid,fieldid,data);
			});
	}
	/*
	params.alert:false：不提醒保存结果，默认提醒
	params.onlyonefield:如果不为空，就表示保存成功后要立即更新第一条记录的该字段的值，即把this.initdata中该第一记录的该字段的值改为最新的。
	此情况用户celledit情况
	params.srcElement:触发此动作的html对象，如按钮
	params.refObject:引用词对象的对象，例如 mcsstable 对象
	*/
	this.save=function(afterSave,params,errCallback)
	{
		var mcsstable=this.params.refObject;
		if (params && params.refObject && params.refObject.params.save){
			params.refObject.params.save(this,params);
			return;
		}
		//检查是否有未上传完的文件
		function checkUploadFile()
		{
			for(var oneupload in document.uploadFiles)
			{
				if (document.uploadFiles[oneupload].uploadstatus=='uploading')
					return false;	
			} 
			return true;			
		}		

		//检查是否有未完成完毕的文件
		if (document.uploadFiles)
		{
			clearInterval(this.checkUploadingTimerId);
			if (checkUploadFile()==false)//发现有正在上传的文件
			{
				this.uploadhint=mcdom.popup('正在上传文件...上传完毕后会自动保存。',{tag:"checkuploading"});
				var _this=this;
				this.checkUploadingTimerId=setInterval(function(){
					if (checkUploadFile())//上传文件完毕或失败了
					{
							clearInterval(_this.checkUploadingTimerId);
							$(_this.uploadhint).remove();
							_this.save(afterSave,params);
					}
				},500);
				return;
			}
		}
		if (!params) params={};
		var showhint=true;
		if (params && params.alert==false)
			showhint=false;
		if (!this.newData || this.newData.length==0)
		{
			mcdom.popup(lang.nonetosave,{obj:params.srcElement,hideheader:true,title:lang.save,fadeOut:true,width:'auto'});
			if (afterSave)
				afterSave(this,mcsstable);			
			return;
		}
		
			var s="",s1="",recordidArr=[];
			for(i=0;i<this.newData.length;i++){
				if (!this.newData[i].mcss_recordtype || this.newData[i].mcss_recordtype=="DELETE" && !this.newData[i].mcss_recordid )
				{}
				else
				{
					recordidArr.push(this.newData[i]['mcss_recordid']);
					s1=JSON.stringify(this.newData[i]);
					s+=s1 +"~|~";
			 	}
				//this.newData[i].mcss_status="doing";
			}
			if (!s)
			{
				if (showhint)
				{
					mcdom.popup(lang.nonetosave,{obj:params.srcElement,title:lang.save,fadeOut:true,width:'auto'});
					this.newData=[];
					//document.uploadFiles=null;
					this.state="";					
					if (afterSave)
						afterSave(this,mcsstable);					
					return;
				}
			}
			var _this=this;
			var projectid='';
			if(mcsstable && mcsstable.params.saveversion){
				mcsstable.params.saveversion(this);	
			}
			if(mcsstable && mcsstable.params){
				projectid=mcsstable.params.usermodel_recordid;
			}
			var urlpath =this.homeUrl+g_systempath+"/save_field_data";
			var d= '{"' + params.onlyonefield + '":"' + params.oldValue + '"}';
			d=uni_cleanSQL(d);
			s=uni_cleanSQL(s);
			var saveRecordTag = 'web';
			var timeid=getTimeId();
			$.post(urlpath, 
				{saveRecordTag:saveRecordTag,projectid:projectid,modelid:this.modeldata.id,tablename:this.modeldata.tablename,eidtedata:s,olddata:d,timeid:timeid},
				function(rtndata){
					var rtn=eval(rtndata);
					var data=rtn.value;
					if (data!="ok" && data!='0') {

						if (errCallback)
						{
							if (data.indexOf("数据已经被他人更新"))
							{
								nowValue = data.split(":")[1];
								
								errCallback(recordidArr[0],params.onlyonefield,params.oldValue,nowValue);
							}
						}
						mcdom.alert("保存失败，原因是:"+data,lang.save,'info','fadeout');
						
					}
					else
					{
						if (showhint)
						{
							if (data=='0')
							{
								mcdom.alert(lang.noupdates,lang.save,'info','fadeout');
							}
							else{
								if (params && params.onlyonefield){
									
									_this.updateInitData(_this.newData[0]);
								}
								/*
								var td = params.srcElement;
								if (td ){
									if (td.divSave && td.divSave.parentNode==td )	
										td.removeChild(td.divSave);	
									td.title="";
									mcsstable.showTip(td,lang.successfullysaved);
								}
							     */
								//mcdom.popup(lang.successfullysaved,{obj:params.srcElement,fadeOut:true,hideheader:true,seconds:3,tag:"SAVEOK"});
								if (mcsstable && mcsstable.params.afterSaveSuceefullly)
									mcsstable.params.afterSaveSuceefullly(mcsstable,data);
							}
						}
						_this.state="SAVED";
						_this.inputedByKey=false;
						//从mcssData中移除已经指定的记录。不能直接执行_this.newData=[];因为异步原因
						if (timeid==rtn.timeid) 
							mcsstable_removeUpdatdNewData(_this.newData,recordidArr);
					
						if (afterSave)
							afterSave(_this,mcsstable);
					}
			});
	}
	

	this.updateInitData=function(record)
	{
		for(f in record){
			if (f!='mcss_recordtype' && f!='mcss_recordid'){
				this.setFieldOldValue(record['recordid'],f,record[f]);
			}
		}
	}	
}

//从mcssData中移除已经指定的记录
function mcsstable_removeUpdatdNewData(mcssNewData,recordidArr)
{						
	for(var i=0;i<recordidArr.length;i++)
	{
		for(var j=0;j<mcssNewData.length;j++)
		{
			if (mcssNewData[j]['mcss_recordid']==recordidArr[i])
			{
				mcssNewData.splice(j,1);
				break;
			}
		}
	}
}

//复制二维数组
function copyArray(arr)
{
	var newArr=new Array();
	for(var i=0;i<arr.length;i++)
	{
		var one={};
		for(var p in arr[i])
		{
			one[p]=arr[i][p];
		}
		newArr.push(one);
	}
	return newArr;
}

/*下面是地址字段代码*/

// 纯JS省市区三级联动
// 2011-11-30 by http://www.cnblogs.com/zjfree
function addressInit(_cmbProvince, _cmbCity, _cmbArea, defaultProvince, defaultCity, defaultArea)
{
    var provinceList = [
	{name:'北京市', cityList:[		   
	{name:'区/县', areaList:['东城区','西城区','崇文区','宣武区','朝阳区','丰台区','石景山区','海淀区','门头沟区','房山区','通州区','顺义区','昌平区','大兴区','怀柔区','平谷区','密云县','延庆县']},		   
	]},
	{name:'上海市', cityList:[		   
	{name:'区/县', areaList:['黄浦区','卢湾区','徐汇区','长宁区','静安区','普陀区','闸北区','虹口区','杨浦区','闵行区','宝山区','嘉定区','浦东新区','金山区','松江区','青浦区','南汇区','奉贤区','崇明县']},		   
	]},
	{name:'天津市', cityList:[		   
	{name:'区/县', areaList:['和平区','河东区','河西区','南开区','河北区','红桥区','塘沽区','汉沽区','大港区','东丽区','西青区','津南区','北辰区','武清区','宝坻区','宁河县','静海县','蓟　县']},		   
	]},
	{name:'重庆市', cityList:[		   
	{name:'区/县', areaList:['万州区','涪陵区','渝中区','大渡口区','江北区','沙坪坝区','九龙坡区','南岸区','北碚区','万盛区','双桥区','渝北区','巴南区','黔江区','长寿区','江津市','合川市','永川市','南川市','綦江县','潼南县','铜梁县','大足县','荣昌县','璧山县','梁平县','城口县','丰都县','垫江县','武隆县','忠　县','开　县','云阳县','奉节县','巫山县','巫溪县','石柱土家族自治县','秀山土家族苗族自治县','酉阳土家族苗族自治县','彭水苗族土家族自治县']},		   
	]},
	{name:'四川省', cityList:[		   
	{name:'成都市', areaList:['区/县','锦江区','青羊区','金牛区','武侯区','成华区','龙泉驿区','青白江区','新都区','温江县','金堂县','双流县','郫　县','大邑县','蒲江县','新津县','都江堰市','彭州市','邛崃市','崇州市']},		   
	{name:'自贡市', areaList:['区/县','自流井区','贡井区','大安区','沿滩区','荣　县','富顺县']},		   
	{name:'攀枝花市', areaList:['区/县','东　区','西　区','仁和区','米易县','盐边县']},		   
	{name:'泸州市', areaList:['区/县','江阳区','纳溪区','龙马潭区','泸　县','合江县','叙永县','古蔺县']},		   
	{name:'德阳市', areaList:['区/县','旌阳区','中江县','罗江县','广汉市','什邡市','绵竹市']},		   
	{name:'绵阳市', areaList:['区/县','涪城区','游仙区','三台县','盐亭县','安　县','梓潼县','北川羌族自治县','平武县','江油市']},		   
	{name:'广元市', areaList:['区/县','市中区','元坝区','朝天区','旺苍县','青川县','剑阁县','苍溪县']},		   
	{name:'遂宁市', areaList:['区/县','船山区','安居区','蓬溪县','射洪县','大英县']},		   
	{name:'内江市', areaList:['区/县','市中区','东兴区','威远县','资中县','隆昌县']},		   
	{name:'乐山市', areaList:['区/县','市中区','沙湾区','五通桥区','金口河区','犍为县','井研县','夹江县','沐川县','峨边彝族自治县','马边彝族自治县','峨眉山市']},		   
	{name:'南充市', areaList:['区/县','顺庆区','高坪区','嘉陵区','南部县','营山县','蓬安县','仪陇县','西充县','阆中市']},		   
	{name:'眉山市', areaList:['区/县','东坡区','仁寿县','彭山县','洪雅县','丹棱县','青神县']},		   
	{name:'宜宾市', areaList:['区/县','翠屏区','宜宾县','南溪县','江安县','长宁县','高　县','珙　县','筠连县','兴文县','屏山县']},		   
	{name:'广安市', areaList:['区/县','广安区','岳池县','武胜县','邻水县','华莹市']},		   
	{name:'达州市', areaList:['区/县','通川区','达　县','宣汉县','开江县','大竹县','渠　县','万源市']},		   
	{name:'雅安市', areaList:['区/县','雨城区','名山县','荥经县','汉源县','石棉县','天全县','芦山县','宝兴县']},		   
	{name:'巴中市', areaList:['区/县','巴州区','通江县','南江县','平昌县']},		   
	{name:'资阳市', areaList:['区/县','雁江区','安岳县','乐至县','简阳市']},		   
	{name:'阿坝藏族羌族自治州', areaList:['汶川县','理　县','茂　县','松潘县','九寨沟县','金川县','小金县','黑水县','马尔康县','壤塘县','阿坝县','若尔盖县','红原县']},		   
	{name:'甘孜藏族自治州', areaList:['康定县','泸定县','丹巴县','九龙县','雅江县','道孚县','炉霍县','甘孜县','新龙县','德格县','白玉县','石渠县','色达县','理塘县','巴塘县','乡城县','稻城县','得荣县']},		   
	{name:'凉山彝族自治州', areaList:['西昌市','木里藏族自治县','盐源县','德昌县','会理县','会东县','宁南县','普格县','布拖县','金阳县','昭觉县','喜德县','冕宁县','越西县','甘洛县','美姑县','雷波县']}
	]},
	{name:'贵州省', cityList:[		   
	{name:'贵阳市', areaList:['区/县','南明区','云岩区','花溪区','乌当区','白云区','小河区','开阳县','息烽县','修文县','清镇市']},		   
	{name:'六盘水市', areaList:['钟山区','六枝特区','水城县','盘　县']},		   
	{name:'遵义市', areaList:['区/县','红花岗区','汇川区','遵义县','桐梓县','绥阳县','正安县','道真仡佬族苗族自治县','务川仡佬族苗族自治县','凤冈县','湄潭县','余庆县','习水县','赤水市','仁怀市']},		   
	{name:'安顺市', areaList:['区/县','西秀区','平坝县','普定县','镇宁布依族苗族自治县','关岭布依族苗族自治县','紫云苗族布依族自治县']},		   
	{name:'铜仁地区', areaList:['铜仁市','江口县','玉屏侗族自治县','石阡县','思南县','印江土家族苗族自治县','德江县','沿河土家族自治县','松桃苗族自治县','万山特区']},		   
	{name:'黔西南布依族苗族自治州', areaList:['兴义市','兴仁县','普安县','晴隆县','贞丰县','望谟县','册亨县','安龙县']},		   
	{name:'毕节地区', areaList:['毕节市','大方县','黔西县','金沙县','织金县','纳雍县','威宁彝族回族苗族自治县','赫章县']},		   
	{name:'黔东南苗族侗族自治州', areaList:['凯里市','黄平县','施秉县','三穗县','镇远县','岑巩县','天柱县','锦屏县','剑河县','台江县','黎平县','榕江县','从江县','雷山县','麻江县','丹寨县']},		   
	{name:'黔南布依族苗族自治州', areaList:['都匀市','福泉市','荔波县','贵定县','瓮安县','独山县','平塘县','罗甸县','长顺县','龙里县','惠水县','三都水族自治县']}
	]},
	{name:'云南省', cityList:[		   
	{name:'昆明市', areaList:['区/县','五华区','盘龙区','官渡区','西山区','东川区','呈贡县','晋宁县','富民县','宜良县','石林彝族自治县','嵩明县','禄劝彝族苗族自治县','寻甸回族彝族自治县','安宁市']},		   
	{name:'曲靖市', areaList:['区/县','麒麟区','马龙县','陆良县','师宗县','罗平县','富源县','会泽县','沾益县','宣威市']},		   
	{name:'玉溪市', areaList:['区/县','红塔区','江川县','澄江县','通海县','华宁县','易门县','峨山彝族自治县','新平彝族傣族自治县','元江哈尼族彝族傣族自治县']},		   
	{name:'保山市', areaList:['区/县','隆阳区','施甸县','腾冲县','龙陵县','昌宁县']},		   
	{name:'昭通市', areaList:['区/县','昭阳区','鲁甸县','巧家县','盐津县','大关县','永善县','绥江县','镇雄县','彝良县','威信县','水富县']},		   
	{name:'丽江市', areaList:['区/县','古城区','玉龙纳西族自治县','永胜县','华坪县','宁蒗彝族自治县']},		   
	{name:'思茅市', areaList:['区/县','翠云区','普洱哈尼族彝族自治县','墨江哈尼族自治县','景东彝族自治县','景谷傣族彝族自治县','镇沅彝族哈尼族拉祜族自治县','江城哈尼族彝族自治县','孟连傣族拉祜族佤族自治县','澜沧拉祜族自治县','西盟佤族自治县']},		   
	{name:'临沧市', areaList:['区/县','临翔区','凤庆县','云　县','永德县','镇康县','双江拉祜族佤族布朗族傣族自治县','耿马傣族佤族自治县','沧源佤族自治县']},		   
	{name:'楚雄彝族自治州', areaList:['楚雄市','双柏县','牟定县','南华县','姚安县','大姚县','永仁县','元谋县','武定县','禄丰县']},		   
	{name:'红河哈尼族彝族自治州', areaList:['个旧市','开远市','蒙自县','屏边苗族自治县','建水县','石屏县','弥勒县','泸西县','元阳县','红河县','金平苗族瑶族傣族自治县','绿春县','河口瑶族自治县']},		   
	{name:'文山壮族苗族自治州', areaList:['文山县','砚山县','西畴县','麻栗坡县','马关县','丘北县','广南县','富宁县']},		   
	{name:'西双版纳傣族自治州', areaList:['景洪市','勐海县','勐腊县']},		   
	{name:'大理白族自治州', areaList:['大理市','漾濞彝族自治县','祥云县','宾川县','弥渡县','南涧彝族自治县','巍山彝族回族自治县','永平县','云龙县','洱源县','剑川县','鹤庆县']},		   
	{name:'德宏傣族景颇族自治州', areaList:['瑞丽市','潞西市','梁河县','盈江县','陇川县']},		   
	{name:'怒江傈僳族自治州', areaList:['泸水县','福贡县','贡山独龙族怒族自治县','兰坪白族普米族自治县']},		   
	{name:'迪庆藏族自治州', areaList:['香格里拉县','德钦县','维西傈僳族自治县']}
	]},
	{name:'西藏省', cityList:[		   
	{name:'拉萨市', areaList:['区/县','城关区','林周县','当雄县','尼木县','曲水县','堆龙德庆县','达孜县','墨竹工卡县']},		   
	{name:'昌都地区', areaList:['昌都县','江达县','贡觉县','类乌齐县','丁青县','察雅县','八宿县','左贡县','芒康县','洛隆县','边坝县']},		   
	{name:'山南地区', areaList:['乃东县','扎囊县','贡嘎县','桑日县','琼结县','曲松县','措美县','洛扎县','加查县','隆子县','错那县','浪卡子县']},		   
	{name:'日喀则地区', areaList:['日喀则市','南木林县','江孜县','定日县','萨迦县','拉孜县','昂仁县','谢通门县','白朗县','仁布县','康马县','定结县','仲巴县','亚东县','吉隆县','聂拉木县','萨嘎县','岗巴县']},		   
	{name:'那曲地区', areaList:['那曲县','嘉黎县','比如县','聂荣县','安多县','申扎县','索　县','班戈县','巴青县','尼玛县']},		   
	{name:'阿里地区', areaList:['普兰县','札达县','噶尔县','日土县','革吉县','改则县','措勤县']},		   
	{name:'林芝地区', areaList:['林芝县','工布江达县','米林县','墨脱县','波密县','察隅县','朗　县']}
	]},
	{name:'河南省', cityList:[		   
	{name:'郑州市', areaList:['区/县','中原区','二七区','管城回族区','金水区','上街区','邙山区','中牟县','巩义市','荥阳市','新密市','新郑市','登封市']},		   
	{name:'开封市', areaList:['区/县','龙亭区','顺河回族区','鼓楼区','南关区','郊　区','杞　县','通许县','尉氏县','开封县','兰考县']},		   
	{name:'洛阳市', areaList:['区/县','老城区','西工区','廛河回族区','涧西区','吉利区','洛龙区','孟津县','新安县','栾川县','嵩　县','汝阳县','宜阳县','洛宁县','伊川县','偃师市']},		   
	{name:'平顶山市', areaList:['区/县','新华区','卫东区','石龙区','湛河区','宝丰县','叶　县','鲁山县','郏　县','舞钢市','汝州市']},		   
	{name:'安阳市', areaList:['区/县','文峰区','北关区','殷都区','龙安区','安阳县','汤阴县','滑　县','内黄县','林州市']},		   
	{name:'鹤壁市', areaList:['区/县','鹤山区','山城区','淇滨区','浚　县','淇　县']},		   
	{name:'新乡市', areaList:['区/县','红旗区','卫滨区','凤泉区','牧野区','新乡县','获嘉县','原阳县','延津县','封丘县','长垣县','卫辉市','辉县市']},		   
	{name:'焦作市', areaList:['区/县','解放区','中站区','马村区','山阳区','修武县','博爱县','武陟县','温　县','济源市','沁阳市','孟州市']},		   
	{name:'濮阳市', areaList:['区/县','华龙区','清丰县','南乐县','范　县','台前县','濮阳县']},		   
	{name:'许昌市', areaList:['区/县','魏都区','许昌县','鄢陵县','襄城县','禹州市','长葛市']},		   
	{name:'漯河市', areaList:['区/县','源汇区','郾城区','召陵区','舞阳县','临颍县']},		   
	{name:'三门峡市', areaList:['区/县','湖滨区','渑池县','陕　县','卢氏县','义马市','灵宝市']},		   
	{name:'南阳市', areaList:['区/县','宛城区','卧龙区','南召县','方城县','西峡县','镇平县','内乡县','淅川县','社旗县','唐河县','新野县','桐柏县','邓州市']},		   
	{name:'商丘市', areaList:['区/县','梁园区','睢阳区','民权县','睢　县','宁陵县','柘城县','虞城县','夏邑县','永城市']},		   
	{name:'信阳市', areaList:['区/县','师河区','平桥区','罗山县','光山县','新　县','商城县','固始县','潢川县','淮滨县','息　县']},		   
	{name:'周口市', areaList:['区/县','川汇区','扶沟县','西华县','商水县','沈丘县','郸城县','淮阳县','太康县','鹿邑县','项城市']},		   
	{name:'驻马店市', areaList:['区/县','驿城区','西平县','上蔡县','平舆县','正阳县','确山县','泌阳县','汝南县','遂平县','新蔡县']}
	]},
	{name:'湖北省', cityList:[		   
	{name:'武汉市', areaList:['区/县','江岸区','江汉区','乔口区','汉阳区','武昌区','青山区','洪山区','东西湖区','汉南区','蔡甸区','江夏区','黄陂区','新洲区']},		   
	{name:'黄石市', areaList:['区/县','黄石港区','西塞山区','下陆区','铁山区','阳新县','大冶市']},		   
	{name:'十堰市', areaList:['区/县','茅箭区','张湾区','郧　县','郧西县','竹山县','竹溪县','房　县','丹江口市']},		   
	{name:'宜昌市', areaList:['区/县','西陵区','伍家岗区','点军区','猇亭区','夷陵区','远安县','兴山县','秭归县','长阳土家族自治县','五峰土家族自治县','宜都市','当阳市','枝江市']},		   
	{name:'襄樊市', areaList:['区/县','襄城区','樊城区','襄阳区','南漳县','谷城县','保康县','老河口市','枣阳市','宜城市']},		   
	{name:'鄂州市', areaList:['区/县','梁子湖区','华容区','鄂城区']},		   
	{name:'荆门市', areaList:['区/县','东宝区','掇刀区','京山县','沙洋县','钟祥市']},		   
	{name:'孝感市', areaList:['区/县','孝南区','孝昌县','大悟县','云梦县','应城市','安陆市','汉川市']},		   
	{name:'荆州市', areaList:['区/县','沙市区','荆州区','公安县','监利县','江陵县','石首市','洪湖市','松滋市']},		   
	{name:'黄冈市', areaList:['区/县','黄州区','团风县','红安县','罗田县','英山县','浠水县','蕲春县','黄梅县','麻城市','武穴市']},		   
	{name:'咸宁市', areaList:['区/县','咸安区','嘉鱼县','通城县','崇阳县','通山县','赤壁市']},		   
	{name:'随州市', areaList:['区/县','曾都区','广水市']},		   
	{name:'恩施土家族苗族自治州', areaList:['恩施市','利川市','建始县','巴东县','宣恩县','咸丰县','来凤县','鹤峰县']},		   
	{name:'省直辖行政单位', areaList:['仙桃市','潜江市','天门市','神农架林区']}
	]},
	{name:'湖南省', cityList:[		   
	{name:'长沙市', areaList:['区/县','芙蓉区','天心区','岳麓区','开福区','雨花区','长沙县','望城县','宁乡县','浏阳市']},		   
	{name:'株洲市', areaList:['区/县','荷塘区','芦淞区','石峰区','天元区','株洲县','攸　县','茶陵县','炎陵县','醴陵市']},		   
	{name:'湘潭市', areaList:['区/县','雨湖区','岳塘区','湘潭县','湘乡市','韶山市']},		   
	{name:'衡阳市', areaList:['区/县','珠晖区','雁峰区','石鼓区','蒸湘区','南岳区','衡阳县','衡南县','衡山县','衡东县','祁东县','耒阳市','常宁市']},		   
	{name:'邵阳市', areaList:['区/县','双清区','大祥区','北塔区','邵东县','新邵县','邵阳县','隆回县','洞口县','绥宁县','新宁县','城步苗族自治县','武冈市']},		   
	{name:'岳阳市', areaList:['区/县','岳阳楼区','云溪区','君山区','岳阳县','华容县','湘阴县','平江县','汨罗市','临湘市']},		   
	{name:'常德市', areaList:['区/县','武陵区','鼎城区','安乡县','汉寿县','澧　县','临澧县','桃源县','石门县','津市市']},		   
	{name:'张家界市', areaList:['区/县','永定区','武陵源区','慈利县','桑植县']},		   
	{name:'益阳市', areaList:['区/县','资阳区','赫山区','南　县','桃江县','安化县','沅江市']},		   
	{name:'郴州市', areaList:['区/县','北湖区','苏仙区','桂阳县','宜章县','永兴县','嘉禾县','临武县','汝城县','桂东县','安仁县','资兴市']},		   
	{name:'永州市', areaList:['区/县','芝山区','冷水滩区','祁阳县','东安县','双牌县','道　县','江永县','宁远县','蓝山县','新田县','江华瑶族自治县']},		   
	{name:'怀化市', areaList:['区/县','鹤城区','中方县','沅陵县','辰溪县','溆浦县','会同县','麻阳苗族自治县','新晃侗族自治县','芷江侗族自治县','靖州苗族侗族自治县','通道侗族自治县','洪江市']},		   
	{name:'娄底市', areaList:['区/县','娄星区','双峰县','新化县','冷水江市','涟源市']},		   
	{name:'湘西土家族苗族自治州', areaList:['吉首市','泸溪县','凤凰县','花垣县','保靖县','古丈县','永顺县','龙山县']}
	]},
	{name:'广东省', cityList:[		   
	{name:'广州市', areaList:['区/县','东山区','荔湾区','越秀区','海珠区','天河区','芳村区','白云区','黄埔区','番禺区','花都区','增城市','从化市']},		   
	{name:'韶关市', areaList:['区/县','武江区','浈江区','曲江区','始兴县','仁化县','翁源县','乳源瑶族自治县','新丰县','乐昌市','南雄市']},		   
	{name:'深圳市', areaList:['区/县','罗湖区','福田区','南山区','宝安区','龙岗区','盐田区']},		   
	{name:'珠海市', areaList:['区/县','香洲区','斗门区','金湾区']},		   
	{name:'汕头市', areaList:['区/县','龙湖区','金平区','濠江区','潮阳区','潮南区','澄海区','南澳县']},		   
	{name:'佛山市', areaList:['区/县','禅城区','南海区','顺德区','三水区','高明区']},		   
	{name:'江门市', areaList:['区/县','蓬江区','江海区','新会区','台山市','开平市','鹤山市','恩平市']},		   
	{name:'湛江市', areaList:['区/县','赤坎区','霞山区','坡头区','麻章区','遂溪县','徐闻县','廉江市','雷州市','吴川市']},		   
	{name:'茂名市', areaList:['区/县','茂南区','茂港区','电白县','高州市','化州市','信宜市']},		   
	{name:'肇庆市', areaList:['区/县','端州区','鼎湖区','广宁县','怀集县','封开县','德庆县','高要市','四会市']},		   
	{name:'惠州市', areaList:['区/县','惠城区','惠阳区','博罗县','惠东县','龙门县']},		   
	{name:'梅州市', areaList:['区/县','梅江区','梅　县','大埔县','丰顺县','五华县','平远县','蕉岭县','兴宁市']},		   
	{name:'汕尾市', areaList:['区/县','城　区','海丰县','陆河县','陆丰市']},		   
	{name:'河源市', areaList:['区/县','源城区','紫金县','龙川县','连平县','和平县','东源县']},		   
	{name:'阳江市', areaList:['区/县','江城区','阳西县','阳东县','阳春市']},		   
	{name:'清远市', areaList:['区/县','清城区','佛冈县','阳山县','连山壮族瑶族自治县','连南瑶族自治县','清新县','英德市','连州市']},		   
	{name:'东莞市', areaList:['东莞市']},		   
	{name:'中山市', areaList:['中山市']},		   
	{name:'潮州市', areaList:['区/县','湘桥区','潮安县','饶平县']},		   
	{name:'揭阳市', areaList:['区/县','榕城区','揭东县','揭西县','惠来县','普宁市']},		   
	{name:'云浮市', areaList:['区/县','云城区','新兴县','郁南县','云安县','罗定市']}
	]},
	{name:'广西省', cityList:[		   
	{name:'南宁市', areaList:['区/县','兴宁区','青秀区','江南区','西乡塘区','良庆区','邕宁区','武鸣县','隆安县','马山县','上林县','宾阳县','横　县']},		   
	{name:'柳州市', areaList:['区/县','城中区','鱼峰区','柳南区','柳北区','柳江县','柳城县','鹿寨县','融安县','融水苗族自治县','三江侗族自治县']},		   
	{name:'桂林市', areaList:['区/县','秀峰区','叠彩区','象山区','七星区','雁山区','阳朔县','临桂县','灵川县','全州县','兴安县','永福县','灌阳县','龙胜各族自治县','资源县','平乐县','荔蒲县','恭城瑶族自治县']},		   
	{name:'梧州市', areaList:['区/县','万秀区','蝶山区','长洲区','苍梧县','藤　县','蒙山县','岑溪市']},		   
	{name:'北海市', areaList:['区/县','海城区','银海区','铁山港区','合浦县']},		   
	{name:'防城港市', areaList:['区/县','港口区','防城区','上思县','东兴市']},		   
	{name:'钦州市', areaList:['区/县','钦南区','钦北区','灵山县','浦北县']},		   
	{name:'贵港市', areaList:['区/县','港北区','港南区','覃塘区','平南县','桂平市']},		   
	{name:'玉林市', areaList:['区/县','玉州区','容　县','陆川县','博白县','兴业县','北流市']},		   
	{name:'百色市', areaList:['区/县','右江区','田阳县','田东县','平果县','德保县','靖西县','那坡县','凌云县','乐业县','田林县','西林县','隆林各族自治县']},		   
	{name:'贺州市', areaList:['区/县','八步区','昭平县','钟山县','富川瑶族自治县']},		   
	{name:'河池市', areaList:['区/县','金城江区','南丹县','天峨县','凤山县','东兰县','罗城仫佬族自治县','环江毛南族自治县','巴马瑶族自治县','都安瑶族自治县','大化瑶族自治县','宜州市']},		   
	{name:'来宾市', areaList:['区/县','兴宾区','忻城县','象州县','武宣县','金秀瑶族自治县','合山市']},		   
	{name:'崇左市', areaList:['区/县','江洲区','扶绥县','宁明县','龙州县','大新县','天等县','凭祥市']}
	]},
	{name:'陕西省', cityList:[		   
	{name:'西安市', areaList:['区/县','新城区','碑林区','莲湖区','灞桥区','未央区','雁塔区','阎良区','临潼区','长安区','蓝田县','周至县','户　县','高陵县']},		   
	{name:'铜川市', areaList:['区/县','王益区','印台区','耀州区','宜君县']},		   
	{name:'宝鸡市', areaList:['区/县','渭滨区','金台区','陈仓区','凤翔县','岐山县','扶风县','眉　县','陇　县','千阳县','麟游县','凤　县','太白县']},		   
	{name:'咸阳市', areaList:['区/县','秦都区','杨凌区','渭城区','三原县','泾阳县','乾　县','礼泉县','永寿县','彬　县','长武县','旬邑县','淳化县','武功县','兴平市']},		   
	{name:'渭南市', areaList:['区/县','临渭区','华　县','潼关县','大荔县','合阳县','澄城县','蒲城县','白水县','富平县','韩城市','华阴市']},		   
	{name:'延安市', areaList:['区/县','宝塔区','延长县','延川县','子长县','安塞县','志丹县','吴旗县','甘泉县','富　县','洛川县','宜川县','黄龙县','黄陵县']},		   
	{name:'汉中市', areaList:['区/县','汉台区','南郑县','城固县','洋　县','西乡县','勉　县','宁强县','略阳县','镇巴县','留坝县','佛坪县']},		   
	{name:'榆林市', areaList:['区/县','榆阳区','神木县','府谷县','横山县','靖边县','定边县','绥德县','米脂县','佳　县','吴堡县','清涧县','子洲县']},		   
	{name:'安康市', areaList:['区/县','汉滨区','汉阴县','石泉县','宁陕县','紫阳县','岚皋县','平利县','镇坪县','旬阳县','白河县']},		   
	{name:'商洛市', areaList:['区/县','商州区','洛南县','丹凤县','商南县','山阳县','镇安县','柞水县']}
	]},
	{name:'甘肃省', cityList:[		   
	{name:'兰州市', areaList:['区/县','城关区','七里河区','西固区','安宁区','红古区','永登县','皋兰县','榆中县']},		   
	{name:'嘉峪关市', areaList:['区/县']},		   
	{name:'金昌市', areaList:['区/县','金川区','永昌县']},		   
	{name:'白银市', areaList:['区/县','白银区','平川区','靖远县','会宁县','景泰县']},		   
	{name:'天水市', areaList:['区/县','秦城区','北道区','清水县','秦安县','甘谷县','武山县','张家川回族自治县']},		   
	{name:'武威市', areaList:['区/县','凉州区','民勤县','古浪县','天祝藏族自治县']},		   
	{name:'张掖市', areaList:['区/县','甘州区','肃南裕固族自治县','民乐县','临泽县','高台县','山丹县']},		   
	{name:'平凉市', areaList:['区/县','崆峒区','泾川县','灵台县','崇信县','华亭县','庄浪县','静宁县']},		   
	{name:'酒泉市', areaList:['区/县','肃州区','金塔县','安西县','肃北蒙古族自治县','阿克塞哈萨克族自治县','玉门市','敦煌市']},		   
	{name:'庆阳市', areaList:['区/县','西峰区','庆城县','环　县','华池县','合水县','正宁县','宁　县','镇原县']},		   
	{name:'定西市', areaList:['区/县','安定区','通渭县','陇西县','渭源县','临洮县','漳　县','岷　县']},		   
	{name:'陇南市', areaList:['区/县','武都区','成　县','文　县','宕昌县','康　县','西和县','礼　县','徽　县','两当县']},		   
	{name:'临夏回族自治州', areaList:['临夏市','临夏县','康乐县','永靖县','广河县','和政县','东乡族自治县','积石山保安族东乡族撒拉族自治县']},		   
	{name:'甘南藏族自治州', areaList:['合作市','临潭县','卓尼县','舟曲县','迭部县','玛曲县','碌曲县','夏河县']}
	]},
	{name:'青海省', cityList:[		   
	{name:'西宁市', areaList:['区/县','城东区','城中区','城西区','城北区','大通回族土族自治县','湟中县','湟源县']},		   
	{name:'海东地区', areaList:['平安县','民和回族土族自治县','乐都县','互助土族自治县','化隆回族自治县','循化撒拉族自治县']},		   
	{name:'海北藏族自治州', areaList:['门源回族自治县','祁连县','海晏县','刚察县']},		   
	{name:'黄南藏族自治州', areaList:['同仁县','尖扎县','泽库县','河南蒙古族自治县']},		   
	{name:'海南藏族自治州', areaList:['共和县','同德县','贵德县','兴海县','贵南县']},		   
	{name:'果洛藏族自治州', areaList:['玛沁县','班玛县','甘德县','达日县','久治县','玛多县']},		   
	{name:'玉树藏族自治州', areaList:['玉树县','杂多县','称多县','治多县','囊谦县','曲麻莱县']},		   
	{name:'海西蒙古族藏族自治州', areaList:['格尔木市','德令哈市','乌兰县','都兰县','天峻县']}
	]},
	{name:'宁夏省', cityList:[		   
	{name:'银川市', areaList:['区/县','兴庆区','西夏区','金凤区','永宁县','贺兰县','灵武市']},		   
	{name:'石嘴山市', areaList:['区/县','大武口区','惠农区','平罗县']},		   
	{name:'吴忠市', areaList:['区/县','利通区','盐池县','同心县','青铜峡市']},		   
	{name:'固原市', areaList:['区/县','原州区','西吉县','隆德县','泾源县','彭阳县','海原县']},		   
	{name:'中卫市', areaList:['区/县','沙坡头区','中宁县']}
	]},
	{name:'新疆省', cityList:[		   
	{name:'乌鲁木齐市', areaList:['区/县','天山区','沙依巴克区','新市区','水磨沟区','头屯河区','达坂城区','东山区','乌鲁木齐县']},		   
	{name:'克拉玛依市', areaList:['区/县','独山子区','克拉玛依区','白碱滩区','乌尔禾区']},		   
	{name:'吐鲁番地区', areaList:['吐鲁番市','鄯善县','托克逊县']},		   
	{name:'哈密地区', areaList:['哈密市','巴里坤哈萨克自治县','伊吾县']},		   
	{name:'昌吉回族自治州', areaList:['昌吉市','阜康市','米泉市','呼图壁县','玛纳斯县','奇台县','吉木萨尔县','木垒哈萨克自治县']},		   
	{name:'博尔塔拉蒙古自治州', areaList:['博乐市','精河县','温泉县']},		   
	{name:'巴音郭楞蒙古自治州', areaList:['库尔勒市','轮台县','尉犁县','若羌县','且末县','焉耆回族自治县','和静县','和硕县','博湖县']},		   
	{name:'阿克苏地区', areaList:['阿克苏市','温宿县','库车县','沙雅县','新和县','拜城县','乌什县','阿瓦提县','柯坪县']},		   
	{name:'克孜勒苏柯尔克孜自治州', areaList:['阿图什市','阿克陶县','阿合奇县','乌恰县']},		   
	{name:'喀什地区', areaList:['喀什市','疏附县','疏勒县','英吉沙县','泽普县','莎车县','叶城县','麦盖提县','岳普湖县','伽师县','巴楚县','塔什库尔干塔吉克自治县']},		   
	{name:'和田地区', areaList:['和田市','和田县','墨玉县','皮山县','洛浦县','策勒县','于田县','民丰县']},		   
	{name:'伊犁哈萨克自治州', areaList:['伊宁市','奎屯市','伊宁县','察布查尔锡伯自治县','霍城县','巩留县','新源县','昭苏县','特克斯县','尼勒克县']},		   
	{name:'塔城地区', areaList:['塔城市','乌苏市','额敏县','沙湾县','托里县','裕民县','和布克赛尔蒙古自治县']},		   
	{name:'阿勒泰地区', areaList:['阿勒泰市','布尔津县','富蕴县','福海县','哈巴河县','青河县','吉木乃县']},		   
	{name:'省直辖行政单位', areaList:['石河子市','阿拉尔市','图木舒克市','五家渠市']}
	]},
	{name:'河北省', cityList:[		   
	{name:'石家庄市', areaList:['区/县','长安区','桥东区','桥西区','新华区','井陉矿区','裕华区','井陉县','正定县','栾城县','行唐县','灵寿县','高邑县','深泽县','赞皇县','无极县','平山县','元氏县','赵　县','辛集市','藁城市','晋州市','新乐市','鹿泉市']},		   
	{name:'唐山市', areaList:['区/县','路南区','路北区','古冶区','开平区','丰南区','丰润区','滦　县','滦南县','乐亭县','迁西县','玉田县','唐海县','遵化市','迁安市']},		   
	{name:'秦皇岛市', areaList:['区/县','海港区','山海关区','北戴河区','青龙满族自治县','昌黎县','抚宁县','卢龙县']},		   
	{name:'邯郸市', areaList:['区/县','邯山区','丛台区','复兴区','峰峰矿区','邯郸县','临漳县','成安县','大名县','涉　县','磁　县','肥乡县','永年县','邱　县','鸡泽县','广平县','馆陶县','魏　县','曲周县','武安市']},		   
	{name:'邢台市', areaList:['区/县','桥东区','桥西区','邢台县','临城县','内丘县','柏乡县','隆尧县','任　县','南和县','宁晋县','巨鹿县','新河县','广宗县','平乡县','威　县','清河县','临西县','南宫市','沙河市']},		   
	{name:'保定市', areaList:['区/县','新市区','北市区','南市区','满城县','清苑县','涞水县','阜平县','徐水县','定兴县','唐　县','高阳县','容城县','涞源县','望都县','安新县','易　县','曲阳县','蠡　县','顺平县','博野县','雄　县','涿州市','定州市','安国市','高碑店市']},		   
	{name:'张家口市', areaList:['区/县','桥东区','桥西区','宣化区','下花园区','宣化县','张北县','康保县','沽源县','尚义县','蔚　县','阳原县','怀安县','万全县','怀来县','涿鹿县','赤城县','崇礼县']},		   
	{name:'承德市', areaList:['区/县','双桥区','双滦区','鹰手营子矿区','承德县','兴隆县','平泉县','滦平县','隆化县','丰宁满族自治县','宽城满族自治县','围场满族蒙古族自治县']},		   
	{name:'沧州市', areaList:['区/县','新华区','运河区','沧　县','青　县','东光县','海兴县','盐山县','肃宁县','南皮县','吴桥县','献　县','孟村回族自治县','泊头市','任丘市','黄骅市','河间市']},		   
	{name:'廊坊市', areaList:['区/县','安次区','广阳区','固安县','永清县','香河县','大城县','文安县','大厂回族自治县','霸州市','三河市']},		   
	{name:'衡水市', areaList:['区/县','桃城区','枣强县','武邑县','武强县','饶阳县','安平县','故城县','景　县','阜城县','冀州市','深州市']}
	]},
	{name:'山西省', cityList:[		   
	{name:'太原市', areaList:['区/县','小店区','迎泽区','杏花岭区','尖草坪区','万柏林区','晋源区','清徐县','阳曲县','娄烦县','古交市']},		   
	{name:'大同市', areaList:['区/县','城　区','矿　区','南郊区','新荣区','阳高县','天镇县','广灵县','灵丘县','浑源县','左云县','大同县']},		   
	{name:'阳泉市', areaList:['区/县','城　区','矿　区','郊　区','平定县','盂　县']},		   
	{name:'长治市', areaList:['区/县','城　区','郊　区','长治县','襄垣县','屯留县','平顺县','黎城县','壶关县','长子县','武乡县','沁　县','沁源县','潞城市']},		   
	{name:'晋城市', areaList:['区/县','城　区','沁水县','阳城县','陵川县','泽州县','高平市']},		   
	{name:'朔州市', areaList:['区/县','朔城区','平鲁区','山阴县','应　县','右玉县','怀仁县']},		   
	{name:'晋中市', areaList:['区/县','榆次区','榆社县','左权县','和顺县','昔阳县','寿阳县','太谷县','祁　县','平遥县','灵石县','介休市']},		   
	{name:'运城市', areaList:['区/县','盐湖区','临猗县','万荣县','闻喜县','稷山县','新绛县','绛　县','垣曲县','夏　县','平陆县','芮城县','永济市','河津市']},		   
	{name:'忻州市', areaList:['区/县','忻府区','定襄县','五台县','代　县','繁峙县','宁武县','静乐县','神池县','五寨县','岢岚县','河曲县','保德县','偏关县','原平市']},		   
	{name:'临汾市', areaList:['区/县','尧都区','曲沃县','翼城县','襄汾县','洪洞县','古　县','安泽县','浮山县','吉　县','乡宁县','大宁县','隰　县','永和县','蒲　县','汾西县','侯马市','霍州市']},		   
	{name:'吕梁市', areaList:['区/县','离石区','文水县','交城县','兴　县','临　县','柳林县','石楼县','岚　县','方山县','中阳县','交口县','孝义市','汾阳市']}
	]},
	{name:'内蒙古省', cityList:[		   
	{name:'呼和浩特市', areaList:['区/县','新城区','回民区','玉泉区','赛罕区','土默特左旗','托克托县','和林格尔县','清水河县','武川县']},		   
	{name:'包头市', areaList:['区/县','东河区','昆都仑区','青山区','石拐区','白云矿区','九原区','土默特右旗','固阳县','达尔罕茂明安联合旗']},		   
	{name:'乌海市', areaList:['区/县','海勃湾区','海南区','乌达区']},		   
	{name:'赤峰市', areaList:['区/县','红山区','元宝山区','松山区','阿鲁科尔沁旗','巴林左旗','巴林右旗','林西县','克什克腾旗','翁牛特旗','喀喇沁旗','宁城县','敖汉旗']},		   
	{name:'通辽市', areaList:['区/县','科尔沁区','科尔沁左翼中旗','科尔沁左翼后旗','开鲁县','库伦旗','奈曼旗','扎鲁特旗','霍林郭勒市']},		   
	{name:'鄂尔多斯市', areaList:['东胜区','达拉特旗','准格尔旗','鄂托克前旗','鄂托克旗','杭锦旗','乌审旗','伊金霍洛旗']},		   
	{name:'呼伦贝尔市', areaList:['区/县','海拉尔区','阿荣旗','莫力达瓦达斡尔族自治旗','鄂伦春自治旗','鄂温克族自治旗','陈巴尔虎旗','新巴尔虎左旗','新巴尔虎右旗','满洲里市','牙克石市','扎兰屯市','额尔古纳市','根河市']},		   
	{name:'巴彦淖尔市', areaList:['区/县','临河区','五原县','磴口县','乌拉特前旗','乌拉特中旗','乌拉特后旗','杭锦后旗']},		   
	{name:'乌兰察布市', areaList:['区/县','集宁区','卓资县','化德县','商都县','兴和县','凉城县','察哈尔右翼前旗','察哈尔右翼中旗','察哈尔右翼后旗','四子王旗','丰镇市']},		   
	{name:'兴安盟', areaList:['乌兰浩特市','阿尔山市','科尔沁右翼前旗','科尔沁右翼中旗','扎赉特旗','突泉县']},		   
	{name:'锡林郭勒盟', areaList:['二连浩特市','锡林浩特市','阿巴嘎旗','苏尼特左旗','苏尼特右旗','东乌珠穆沁旗','西乌珠穆沁旗','太仆寺旗','镶黄旗','正镶白旗','正蓝旗','多伦县']},		   
	{name:'阿拉善盟', areaList:['阿拉善左旗','阿拉善右旗','额济纳旗']}
	]},
	{name:'江苏省', cityList:[		   
	{name:'南京市', areaList:['区/县','玄武区','白下区','秦淮区','建邺区','鼓楼区','下关区','浦口区','栖霞区','雨花台区','江宁区','六合区','溧水县','高淳县']},		   
	{name:'无锡市', areaList:['区/县','崇安区','南长区','北塘区','锡山区','惠山区','滨湖区','江阴市','宜兴市']},		   
	{name:'徐州市', areaList:['区/县','鼓楼区','云龙区','九里区','贾汪区','泉山区','丰　县','沛　县','铜山县','睢宁县','新沂市','邳州市']},		   
	{name:'常州市', areaList:['区/县','天宁区','钟楼区','戚墅堰区','新北区','武进区','溧阳市','金坛市']},		   
	{name:'苏州市', areaList:['区/县','沧浪区','平江区','金阊区','虎丘区','吴中区','相城区','常熟市','张家港市','昆山市','吴江市','太仓市']},		   
	{name:'南通市', areaList:['区/县','崇川区','港闸区','海安县','如东县','启东市','如皋市','通州市','海门市']},		   
	{name:'连云港市', areaList:['区/县','连云区','新浦区','海州区','赣榆县','东海县','灌云县','灌南县']},		   
	{name:'淮安市', areaList:['区/县','清河区','楚州区','淮阴区','清浦区','涟水县','洪泽县','盱眙县','金湖县']},		   
	{name:'盐城市', areaList:['区/县','亭湖区','盐都区','响水县','滨海县','阜宁县','射阳县','建湖县','东台市','大丰市']},		   
	{name:'扬州市', areaList:['区/县','广陵区','邗江区','郊　区','宝应县','仪征市','高邮市','江都市']},		   
	{name:'镇江市', areaList:['区/县','京口区','润州区','丹徒区','丹阳市','扬中市','句容市']},		   
	{name:'泰州市', areaList:['区/县','海陵区','高港区','兴化市','靖江市','泰兴市','姜堰市']},		   
	{name:'宿迁市', areaList:['区/县','宿城区','宿豫区','沭阳县','泗阳县','泗洪县']}
	]},
	{name:'浙江省', cityList:[		   
	{name:'杭州市', areaList:['区/县','上城区','下城区','江干区','拱墅区','西湖区','滨江区','萧山区','余杭区','桐庐县','淳安县','建德市','富阳市','临安市']},		   
	{name:'宁波市', areaList:['区/县','海曙区','江东区','江北区','北仑区','镇海区','鄞州区','象山县','宁海县','余姚市','慈溪市','奉化市']},		   
	{name:'温州市', areaList:['区/县','鹿城区','龙湾区','瓯海区','洞头县','永嘉县','平阳县','苍南县','文成县','泰顺县','瑞安市','乐清市']},		   
	{name:'嘉兴市', areaList:['区/县','秀城区','秀洲区','嘉善县','海盐县','海宁市','平湖市','桐乡市']},		   
	{name:'湖州市', areaList:['区/县','吴兴区','南浔区','德清县','长兴县','安吉县']},		   
	{name:'绍兴市', areaList:['区/县','越城区','绍兴县','新昌县','诸暨市','上虞市','嵊州市']},		   
	{name:'金华市', areaList:['区/县','婺城区','金东区','武义县','浦江县','磐安县','兰溪市','义乌市','东阳市','永康市']},		   
	{name:'衢州市', areaList:['区/县','柯城区','衢江区','常山县','开化县','龙游县','江山市']},		   
	{name:'舟山市', areaList:['区/县','定海区','普陀区','岱山县','嵊泗县']},		   
	{name:'台州市', areaList:['区/县','椒江区','黄岩区','路桥区','玉环县','三门县','天台县','仙居县','温岭市','临海市']},		   
	{name:'丽水市', areaList:['区/县','莲都区','青田县','缙云县','遂昌县','松阳县','云和县','庆元县','景宁畲族自治县','龙泉市']}
	]},
	{name:'安徽省', cityList:[		   
	{name:'合肥市', areaList:['区/县','瑶海区','庐阳区','蜀山区','包河区','长丰县','肥东县','肥西县']},		   
	{name:'芜湖市', areaList:['区/县','镜湖区','马塘区','新芜区','鸠江区','芜湖县','繁昌县','南陵县']},		   
	{name:'蚌埠市', areaList:['区/县','龙子湖区','蚌山区','禹会区','淮上区','怀远县','五河县','固镇县']},		   
	{name:'淮南市', areaList:['区/县','大通区','田家庵区','谢家集区','八公山区','潘集区','凤台县']},		   
	{name:'马鞍山市', areaList:['区/县','金家庄区','花山区','雨山区','当涂县']},		   
	{name:'淮北市', areaList:['区/县','杜集区','相山区','烈山区','濉溪县']},		   
	{name:'铜陵市', areaList:['区/县','铜官山区','狮子山区','郊　区','铜陵县']},		   
	{name:'安庆市', areaList:['区/县','迎江区','大观区','郊　区','怀宁县','枞阳县','潜山县','太湖县','宿松县','望江县','岳西县','桐城市']},		   
	{name:'黄山市', areaList:['区/县','屯溪区','黄山区','徽州区','歙　县','休宁县','黟　县','祁门县']},		   
	{name:'滁州市', areaList:['区/县','琅琊区','南谯区','来安县','全椒县','定远县','凤阳县','天长市','明光市']},		   
	{name:'阜阳市', areaList:['区/县','颍州区','颍东区','颍泉区','临泉县','太和县','阜南县','颍上县','界首市']},		   
	{name:'宿州市', areaList:['区/县','墉桥区','砀山县','萧　县','灵璧县','泗　县']},		   
	{name:'巢湖市', areaList:['区/县','居巢区','庐江县','无为县','含山县','和　县']},		   
	{name:'六安市', areaList:['区/县','金安区','裕安区','寿　县','霍邱县','舒城县','金寨县','霍山县']},		   
	{name:'亳州市', areaList:['区/县','谯城区','涡阳县','蒙城县','利辛县']},		   
	{name:'池州市', areaList:['区/县','贵池区','东至县','石台县','青阳县']},		   
	{name:'宣城市', areaList:['区/县','宣州区','郎溪县','广德县','泾　县','绩溪县','旌德县','宁国市']}
	]},
	{name:'福建省', cityList:[		   
	{name:'福州市', areaList:['区/县','鼓楼区','台江区','仓山区','马尾区','晋安区','闽侯县','连江县','罗源县','闽清县','永泰县','平潭县','福清市','长乐市']},		   
	{name:'厦门市', areaList:['区/县','思明区','海沧区','湖里区','集美区','同安区','翔安区']},		   
	{name:'莆田市', areaList:['区/县','城厢区','涵江区','荔城区','秀屿区','仙游县']},		   
	{name:'三明市', areaList:['区/县','梅列区','三元区','明溪县','清流县','宁化县','大田县','尤溪县','沙　县','将乐县','泰宁县','建宁县','永安市']},		   
	{name:'泉州市', areaList:['区/县','鲤城区','丰泽区','洛江区','泉港区','惠安县','安溪县','永春县','德化县','金门县','石狮市','晋江市','南安市']},		   
	{name:'漳州市', areaList:['区/县','芗城区','龙文区','云霄县','漳浦县','诏安县','长泰县','东山县','南靖县','平和县','华安县','龙海市']},		   
	{name:'南平市', areaList:['区/县','延平区','顺昌县','浦城县','光泽县','松溪县','政和县','邵武市','武夷山市','建瓯市','建阳市']},		   
	{name:'龙岩市', areaList:['区/县','新罗区','长汀县','永定县','上杭县','武平县','连城县','漳平市']},		   
	{name:'宁德市', areaList:['区/县','蕉城区','霞浦县','古田县','屏南县','寿宁县','周宁县','柘荣县','福安市','福鼎市']}
	]},
	{name:'江西省', cityList:[		   
	{name:'南昌市', areaList:['区/县','东湖区','西湖区','青云谱区','湾里区','青山湖区','南昌县','新建县','安义县','进贤县']},		   
	{name:'景德镇市', areaList:['区/县','昌江区','珠山区','浮梁县','乐平市']},		   
	{name:'萍乡市', areaList:['区/县','安源区','湘东区','莲花县','上栗县','芦溪县']},		   
	{name:'九江市', areaList:['区/县','庐山区','浔阳区','九江县','武宁县','修水县','永修县','德安县','星子县','都昌县','湖口县','彭泽县','瑞昌市']},		   
	{name:'新余市', areaList:['区/县','渝水区','分宜县']},		   
	{name:'鹰潭市', areaList:['区/县','月湖区','余江县','贵溪市']},		   
	{name:'赣州市', areaList:['区/县','章贡区','赣　县','信丰县','大余县','上犹县','崇义县','安远县','龙南县','定南县','全南县','宁都县','于都县','兴国县','会昌县','寻乌县','石城县','瑞金市','南康市']},		   
	{name:'吉安市', areaList:['区/县','吉州区','青原区','吉安县','吉水县','峡江县','新干县','永丰县','泰和县','遂川县','万安县','安福县','永新县','井冈山市']},		   
	{name:'宜春市', areaList:['区/县','袁州区','奉新县','万载县','上高县','宜丰县','靖安县','铜鼓县','丰城市','樟树市','高安市']},		   
	{name:'抚州市', areaList:['区/县','临川区','南城县','黎川县','南丰县','崇仁县','乐安县','宜黄县','金溪县','资溪县','东乡县','广昌县']},		   
	{name:'上饶市', areaList:['区/县','信州区','上饶县','广丰县','玉山县','铅山县','横峰县','弋阳县','余干县','鄱阳县','万年县','婺源县','德兴市']}
	]},
	{name:'山东省', cityList:[		   
	{name:'济南市', areaList:['区/县','历下区','市中区','槐荫区','天桥区','历城区','长清区','平阴县','济阳县','商河县','章丘市']},		   
	{name:'青岛市', areaList:['区/县','市南区','市北区','四方区','黄岛区','崂山区','李沧区','城阳区','胶州市','即墨市','平度市','胶南市','莱西市']},		   
	{name:'淄博市', areaList:['区/县','淄川区','张店区','博山区','临淄区','周村区','桓台县','高青县','沂源县']},		   
	{name:'枣庄市', areaList:['区/县','市中区','薛城区','峄城区','台儿庄区','山亭区','滕州市']},		   
	{name:'东营市', areaList:['区/县','东营区','河口区','垦利县','利津县','广饶县']},		   
	{name:'烟台市', areaList:['区/县','芝罘区','福山区','牟平区','莱山区','长岛县','龙口市','莱阳市','莱州市','蓬莱市','招远市','栖霞市','海阳市']},		   
	{name:'潍坊市', areaList:['区/县','潍城区','寒亭区','坊子区','奎文区','临朐县','昌乐县','青州市','诸城市','寿光市','安丘市','高密市','昌邑市']},		   
	{name:'济宁市', areaList:['区/县','市中区','任城区','微山县','鱼台县','金乡县','嘉祥县','汶上县','泗水县','梁山县','曲阜市','兖州市','邹城市']},		   
	{name:'泰安市', areaList:['区/县','泰山区','岱岳区','宁阳县','东平县','新泰市','肥城市']},		   
	{name:'威海市', areaList:['区/县','环翠区','文登市','荣成市','乳山市']},		   
	{name:'日照市', areaList:['区/县','东港区','岚山区','五莲县','莒　县']},		   
	{name:'莱芜市', areaList:['区/县','莱城区','钢城区']},		   
	{name:'临沂市', areaList:['区/县','兰山区','罗庄区','河东区','沂南县','郯城县','沂水县','苍山县','费　县','平邑县','莒南县','蒙阴县','临沭县']},		   
	{name:'德州市', areaList:['区/县','德城区','陵　县','宁津县','庆云县','临邑县','齐河县','平原县','夏津县','武城县','乐陵市','禹城市']},		   
	{name:'聊城市', areaList:['区/县','东昌府区','阳谷县','莘　县','茌平县','东阿县','冠　县','高唐县','临清市']},		   
	{name:'滨州市', areaList:['区/县','滨城区','惠民县','阳信县','无棣县','沾化县','博兴县','邹平县']},		   
	{name:'荷泽市', areaList:['区/县','牡丹区','曹　县','单　县','成武县','巨野县','郓城县','鄄城县','定陶县','东明县']}
	]},
	{name:'辽宁省', cityList:[		   
	{name:'沈阳市', areaList:['区/县','和平区','沈河区','大东区','皇姑区','铁西区','苏家屯区','东陵区','新城子区','于洪区','辽中县','康平县','法库县','新民市']},		   
	{name:'大连市', areaList:['区/县','中山区','西岗区','沙河口区','甘井子区','旅顺口区','金州区','长海县','瓦房店市','普兰店市','庄河市']},		   
	{name:'鞍山市', areaList:['区/县','铁东区','铁西区','立山区','千山区','台安县','岫岩满族自治县','海城市']},		   
	{name:'抚顺市', areaList:['区/县','新抚区','东洲区','望花区','顺城区','抚顺县','新宾满族自治县','清原满族自治县']},		   
	{name:'本溪市', areaList:['区/县','平山区','溪湖区','明山区','南芬区','本溪满族自治县','桓仁满族自治县']},		   
	{name:'丹东市', areaList:['区/县','元宝区','振兴区','振安区','宽甸满族自治县','东港市','凤城市']},		   
	{name:'锦州市', areaList:['区/县','古塔区','凌河区','太和区','黑山县','义　县','凌海市','北宁市']},		   
	{name:'营口市', areaList:['区/县','站前区','西市区','鲅鱼圈区','老边区','盖州市','大石桥市']},		   
	{name:'阜新市', areaList:['区/县','海州区','新邱区','太平区','清河门区','细河区','阜新蒙古族自治县','彰武县']},		   
	{name:'辽阳市', areaList:['区/县','白塔区','文圣区','宏伟区','弓长岭区','太子河区','辽阳县','灯塔市']},		   
	{name:'盘锦市', areaList:['区/县','双台子区','兴隆台区','大洼县','盘山县']},		   
	{name:'铁岭市', areaList:['区/县','银州区','清河区','铁岭县','西丰县','昌图县','调兵山市','开原市']},		   
	{name:'朝阳市', areaList:['区/县','双塔区','龙城区','朝阳县','建平县','喀喇沁左翼蒙古族自治县','北票市','凌源市']},		   
	{name:'葫芦岛市', areaList:['区/县','连山区','龙港区','南票区','绥中县','建昌县','兴城市']}
	]},
	{name:'吉林省', cityList:[		   
	{name:'长春市', areaList:['区/县','南关区','宽城区','朝阳区','二道区','绿园区','双阳区','农安县','九台市','榆树市','德惠市']},		   
	{name:'吉林市', areaList:['区/县','昌邑区','龙潭区','船营区','丰满区','永吉县','蛟河市','桦甸市','舒兰市','磐石市']},		   
	{name:'四平市', areaList:['区/县','铁西区','铁东区','梨树县','伊通满族自治县','公主岭市','双辽市']},		   
	{name:'辽源市', areaList:['区/县','龙山区','西安区','东丰县','东辽县']},		   
	{name:'通化市', areaList:['区/县','东昌区','二道江区','通化县','辉南县','柳河县','梅河口市','集安市']},		   
	{name:'白山市', areaList:['区/县','八道江区','抚松县','靖宇县','长白朝鲜族自治县','江源县','临江市']},		   
	{name:'松原市', areaList:['区/县','宁江区','前郭尔罗斯蒙古族自治县','长岭县','乾安县','扶余县']},		   
	{name:'白城市', areaList:['区/县','洮北区','镇赉县','通榆县','洮南市','大安市']},		   
	{name:'延边朝鲜族自治州', areaList:['延吉市','图们市','敦化市','珲春市','龙井市','和龙市','汪清县','安图县']}
	]},
	{name:'黑龙江省', cityList:[		   
	{name:'哈尔滨市', areaList:['区/县','道里区','南岗区','道外区','香坊区','动力区','平房区','松北区','呼兰区','依兰县','方正县','宾　县','巴彦县','木兰县','通河县','延寿县','阿城市','双城市','尚志市','五常市']},		   
	{name:'齐齐哈尔市', areaList:['区/县','龙沙区','建华区','铁锋区','昂昂溪区','富拉尔基区','碾子山区','梅里斯达斡尔族区','龙江县','依安县','泰来县','甘南县','富裕县','克山县','克东县','拜泉县','讷河市']},		   
	{name:'鸡西市', areaList:['区/县','鸡冠区','恒山区','滴道区','梨树区','城子河区','麻山区','鸡东县','虎林市','密山市']},		   
	{name:'鹤岗市', areaList:['区/县','向阳区','工农区','南山区','兴安区','东山区','兴山区','萝北县','绥滨县']},		   
	{name:'双鸭山市', areaList:['区/县','尖山区','岭东区','四方台区','宝山区','集贤县','友谊县','宝清县','饶河县']},		   
	{name:'大庆市', areaList:['区/县','萨尔图区','龙凤区','让胡路区','红岗区','大同区','肇州县','肇源县','林甸县','杜尔伯特蒙古族自治县']},		   
	{name:'伊春市', areaList:['区/县','伊春区','南岔区','友好区','西林区','翠峦区','新青区','美溪区','金山屯区','五营区','乌马河区','汤旺河区','带岭区','乌伊岭区','红星区','上甘岭区','嘉荫县','铁力市']},		   
	{name:'佳木斯市', areaList:['区/县','永红区','向阳区','前进区','东风区','郊　区','桦南县','桦川县','汤原县','抚远县','同江市','富锦市']},		   
	{name:'七台河市', areaList:['区/县','新兴区','桃山区','茄子河区','勃利县']},		   
	{name:'牡丹江市', areaList:['区/县','东安区','阳明区','爱民区','西安区','东宁县','林口县','绥芬河市','海林市','宁安市','穆棱市']},		   
	{name:'黑河市', areaList:['区/县','爱辉区','嫩江县','逊克县','孙吴县','北安市','五大连池市']},		   
	{name:'绥化市', areaList:['区/县','北林区','望奎县','兰西县','青冈县','庆安县','明水县','绥棱县','安达市','肇东市','海伦市']},		   
	{name:'大兴安岭地区', areaList:['呼玛县','塔河县','漠河县']}
	]},
	{name:'海南省', cityList:[		   
	{name:'海口市', areaList:['区/县','秀英区','龙华区','琼山区','美兰区']},		   
	{name:'三亚市', areaList:['区/县']},		   
	{name:'省直辖县级行政单位', areaList:['五指山市','琼海市','儋州市','文昌市','万宁市','东方市','定安县','屯昌县','澄迈县','临高县','白沙黎族自治县','昌江黎族自治县','乐东黎族自治县','陵水黎族自治县','保亭黎族苗族自治县','琼中黎族苗族自治县','西沙群岛','南沙群岛','中沙群岛的岛礁及其海域']}
	]},
	{name:'台湾省', cityList:[		   
	{name:'台北市', areaList:['区/县','大安区','大同区','内湖区','南岗区','松山区','万华区','文山区','信义区','中山区','中正区','北投区','士林区']},		   
	{name:'台中市', areaList:['区/县','北区','北屯区','大安区','大肚区','大甲区','大里区','大雅区','东区','丰原区','后里区','龙井区','南区','南屯区','清水区','三义乡','沙鹿区','神冈区','石岗区','潭子区','通宵镇','外埔区','乌日区','梧栖区','西区','西屯区','苑里镇','中区','太平区','雾峰区','东势镇','和平乡','新设乡']},		   
	{name:'新北市', areaList:['区/县','林口区','莺歌区','八里区','板桥区','芦洲区','淡水区','三重区','深坑区','树林区','泰山区','土城区','五股区','新庄区','永和区','中和区','万里区','金山区','石碇区','瑞芳区','贡寮区','坪林区','乌来区','三芝区','石门区','平溪区','双溪区','三峡区','汐止区','新店区']},		   
	{name:'台南市', areaList:['区/县','安定区','安南区','安平区','北区','东区','永康区','归仁区','仁德区','关庙区','官田区','佳里区','六甲区','麻豆区','南山区','上区','善化区','西岗区','西区','新市区','中区','新化区','新营区','左镇区','玉井区','南化区','楠西区','龙崎区','七股区','将军区','学甲区','北门区','后壁区','白河区','东山区','下营区','柳营区','盐水区','大内区']},		   
	{name:'高雄市', areaList:['区/县','阿莲区','大寮区','大社区','大树区','凤山区','冈山区','鼓山区','湖内区','林园区','苓雅区','路竹区','楠梓区','鸟松区','骑津区','前金区','前镇区','桥头区','仁武区','三民区','小港区','新兴区','盐埕区','燕巢区','永安区','梓官区','左营区','田寮乡','六龟乡','茂林乡','内门乡','桃源乡','甲仙乡','弥陀乡','旗山镇','美浓镇','那玛夏乡','茄莡乡','杉林乡']},		   
	{name:'基隆市', areaList:['区/县','七堵区','中山区','中正区','仁爱区','信义区','安乐区','暧暧区']},		   
	{name:'新竹市', areaList:['区/县','东区','北区','香山区']},		   
	{name:'嘉义市', areaList:['区/县','东区','西区']},		   
	{name:'桃园县', areaList:['区/县','桃园市','中坜市','平镇市','大溪镇','八德市','大园乡','观音乡','龟山乡','复兴乡','龙潭乡','芦竹乡','新屋乡','杨梅市']},		   
	{name:'新竹县', areaList:['区/县','竹北市','湖口乡','新丰乡','新浦镇','关西镇','芎林乡','竹东镇','峨眉乡','宝山乡','五峰乡','横山乡','北埔乡','尖石乡']},		   
	{name:'苗栗县', areaList:['区/县','竹南镇','头份镇','三湾乡','后龙镇','通宵镇','苑里镇','苗栗市','造桥乡','头屋乡','公馆乡','铜锣乡','三义乡','西湖乡','南庄乡','狮潭乡','大湖乡','泰安乡','卓兰镇']},		   
	{name:'彰化县', areaList:['区/县','北斗镇','草屯镇','大村乡','二水乡','芳苑乡','芬园乡','福兴乡','和美镇','花坛乡','鹿港镇','南投市','埤头乡','埔盐乡','埔心乡','社头乡','伸港乡','田尾乡','田中镇','溪湖镇','线西乡','秀水乡','永镇乡','员林镇','彰化市','二林镇','大城乡','竹塘乡','溪州乡']},		   
	{name:'南投县', areaList:['区/县','埔里镇','竹山镇','集集镇','名间乡','鹿谷乡','中寮乡','鱼池乡','国姓乡','水里乡','信义乡','仁爱乡','南投市','草屯镇','琉球乡']},
	{name:'云林县', areaList:['区/县','大埤乡','土库镇','林内乡','莿桐乡','西螺镇','仓背乡','古坑乡','褒忠乡','东势乡','台西乡','麦寮乡','二仑乡','北港镇','水林乡','口湖乡','四湖乡','元长乡','斗六市','斗南镇','虎尾镇']},	
	{name:'嘉义县', areaList:['区/县','竹崎乡','番路乡','梅山乡','阿里山乡','东石乡','大埔乡','西口乡','义竹乡','布袋镇','大林镇','六脚乡','鹿草乡','民雄乡','朴子市','水上乡','太保市','新港乡','中埔乡']},	
	{name:'屏东县', areaList:['区/县','屏东市','万丹乡','长治乡','内埔乡','潮州镇','三地门乡','三义乡','狮子乡','牡丹乡','高树乡','满州乡','万峦乡','春日乡','雾台乡','泰武乡','玛家乡','恒春镇','枋寮乡','东港镇','林边乡','彷山乡','里港乡','车城乡','盐埔乡','九如乡','新园乡','新埤乡','佳冬乡','竹田乡','南州乡','崁顶乡','麟洛乡']},	
	{name:'宜兰县', areaList:['区/县','头城镇','宜兰市','礁溪乡','壮围乡','五结乡','罗东镇','员山乡','南澳乡','冬山乡','三星乡','苏澳镇']},	
	{name:'花溪县', areaList:['区/县','花莲市','光复乡','玉里镇','新城乡','吉安乡','寿丰乡','凤林镇','丰滨乡','瑞惠乡','富里乡','秀林乡','万荣乡','卓溪乡']},	
	{name:'台东县', areaList:['区/县','台东市','成功镇','关山镇','卑南乡','大武乡','太麻里乡','东河乡','长滨乡','鹿野乡','池上乡','延平乡','海端乡','达仁乡','金峰乡']},	
	{name:'澎湖县', areaList:['区/县','马公市','湖西乡','白沙乡','西屿乡','望安乡','七美乡']},	
	{name:'金门县', areaList:['区/县','金城镇','金湖镇','金沙镇','金宁乡','烈屿乡','乌丘乡']},	
	{name:'连江县', areaList:['区/县','南竿乡','北竿乡','莒光乡','东引乡']},	
	]},
	{name:'香港市', cityList:[		   
	{name:'香港岛', areaList:['区/县','中西区','湾仔区','东区','南区']},		   
	{name:'九龙半岛', areaList:['区/县','九龙城区','观塘区','深水埗区','黄大仙区','油尖旺区']},		   
	{name:'新界', areaList:['区/县','荃湾区','屯门区','元朗区','葵青区','北区','大浦区','沙田区','西贡区']},		   
	{name:'离岛', areaList:['区/县','离岛']},		   
	]},
	{name:'澳门市', cityList:[		   
	{name:'区/县', areaList:['澳门半岛','氹仔','路环']},		   
	]},
	{name:'海外', cityList:[		   
	{name:'其他', areaList:['其他']},		   
	]},
	];
	var cmbProvince = _cmbProvince;
	var cmbCity = _cmbCity;
	var cmbArea = _cmbArea;
	
	function cmbSelect(cmb, str)
	{
		for(var i=0; i<cmb.options.length; i++)
		{
			if(cmb.options[i].value == str)
			{
				cmb.selectedIndex = i;
				return;
			}
		}
	}
	function cmbAddOption(cmb, str, obj)
	{
		var option = document.createElement("OPTION");
		cmb.options.add(option);
		option.innerHTML = str;
		option.value = str;
		option.obj = obj;
	}
	
	function changeCity()
	{
		cmbArea.options.length = 0;
		if(cmbCity.selectedIndex == -1)return;
		var item = cmbCity.options[cmbCity.selectedIndex].obj;
		for(var i=0; i<item.areaList.length; i++)
		{
			cmbAddOption(cmbArea, item.areaList[i], null);
		}
		cmbSelect(cmbArea, defaultArea);
	}
	function changeProvince()
	{
		cmbCity.options.length = 0;
		cmbCity.onchange = null;
		if(cmbProvince.selectedIndex == -1)return;
		var item = cmbProvince.options[cmbProvince.selectedIndex].obj;
		for(var i=0; i<item.cityList.length; i++)
		{
			cmbAddOption(cmbCity, item.cityList[i].name, item.cityList[i]);
		}
		cmbSelect(cmbCity, defaultCity);
		changeCity();
		cmbCity.onchange = changeCity;
	}
	
	for(var i=0; i<provinceList.length; i++)
	{
		cmbAddOption(cmbProvince, provinceList[i].name, provinceList[i]);
	}
	cmbSelect(cmbProvince, defaultProvince);
	changeProvince();
	cmbProvince.onchange = changeProvince;
}
/*上面是地址字段代码*/

//获得时间随机数，从年份的最后2位，到毫秒，最后加5	位随机数，共20位。例如13112918400745636211
function getTimeId()
{
	return uni_getTimeId();
}
function getEvent() //同时兼容ie和ff的写法 
{  
	if(document.all)  return window.event;    
	func=getEvent.caller;        
	while(func!=null){  
		var arg0=func.arguments[0]; 
		if(arg0) 
		{ 
		  if((arg0.constructor==Event || arg0.constructor ==MouseEvent) || (typeof(arg0)=="object" && arg0.preventDefault && arg0.stopPropagation)) 
		  {  
		  return arg0; 
		  } 
		} 
		func=func.caller; 
	} 
	return null; 
} 
function viewImage(evt){
	var event = getEvent();
	var imgTag=event.srcElement || event.target;
	var rooturl=g_rooturl;
	if(!imgTag.src)
		imgTag.src = $(evt).attr("src");
   var imgPath=imgTag.src.replace("a.jpg",".jpg");//取得弹出的大图url
   var imgSrcLeft = imgPath.substring(0,imgPath.length-4);
   var imgSrcRight = imgPath.substring(imgPath.length-4);
   if(imgSrcLeft.substring(imgSrcLeft.length-7)=="[small]")
		imgSrcLeft = imgSrcLeft.substring(0,imgSrcLeft.length-7);
	imgPath = imgSrcLeft+imgSrcRight;
	if(imgPath && uni_global.issaas){
		var pathArr = imgPath.split("uploadfile/");
		imgPath = uni_global.filepath+pathArr[1];
	}
   var tagTop=Math.max(document.documentElement.scrollTop,document.body.scrollTop);
   var tag=document.createElement("div");
   tag.style.cssText="z-index:100000;width:100%;height:"+Math.max(document.body.clientHeight,document.body.offsetHeight)+"px;position:absolute;background:white;top:0;filter: Alpha(Opacity=80);Opacity:0.8;";
   tag.ondblclick=function(){var clsOK=confirm("确定要取消图片显示吗?"); if(clsOK){closes();}};
   var tagImg=document.createElement("div");
   tagImg.style.cssText="z-index:100001;overflow:auto;text-align:center;position:absolute;width:200px;border:5px solid #B4D14E;background:gray;color:white;left:"+(parseInt(document.body.offsetWidth)/2-100)+"px;top:"+(document.documentElement.clientHeight/3+tagTop)+"px;"
   tagImg.innerHTML="<div style='padding:10px;background:#cccccc;border:1px solid white'><img src='"+rooturl+"/Public/themes/default/images/loading.gif' /><br /><br /><b style='color:#999999;font-weight:normal'>图片加载中...</b><br /></div>";
   var closeTag=document.createElement("div");
   closeTag.style.cssText="display:block;position:absolute;right:0px;top:0px;cursor:pointer;";
   closeTag.innerHTML="<img src='"+rooturl+"/Public/Images/closebutton.png' title='点击关闭浏览'>";
   closeTag.onclick=closes;
   document.body.appendChild(tag);
   document.body.appendChild(tagImg);
   var img=new Image();
    img.src=imgPath;
	var wi=false;////图片可以存在的最大值
	if(img.height>(window.screen.height-200)||img.width>(window.screen.width-200)){
		wi=true
	}
    img.style.cssText="border:1px solid #cccccc;filter: Alpha(Opacity=0);Opacity:0;";
	//tagImg.oncontextmenu=function(){var clsOK=confirm("确定要取消图片显示吗?"); if(clsOK){closes();};return false};
   var barShow,imgTime;
   img.complete?ImgOK():img.onload=ImgOK;
   function ImgOK(){
	   debugger
    var Stop1=false,Stop2=false,temp=0;
    var tx=tagImg.offsetWidth,ty=tagImg.offsetHeight;
    var ix=img.width,iy=img.height;
    var sx=document.documentElement.clientWidth,sy=Math.min(document.documentElement.clientHeight,document.body.clientHeight/*opera*/);
    var xx=ix>sx?sx-50:ix+4,yy=iy>sy?sy-50:iy+3;
    var maxTime=setInterval(function(){
     temp+=35;
     if((tx+temp)<xx){
      tagImg.style.width=(tx+temp)+"px";
      tagImg.style.left=(sx-(tx+temp))/2+"px";
     }else{
      Stop1=true;
      tagImg.style.width=xx+"px";
      tagImg.style.left=(sx-xx)/2+"px";
     }
     if((ty+temp)<yy){
      tagImg.style.height=(ty+temp)+"px";
      tagImg.style.top=(tagTop+((sy-(ty+temp))/2))+"px";
     }else{
      Stop2=true;
      tagImg.style.height=yy+"px";
      tagImg.style.top=(tagTop+((sy-yy)/2))+"px";
     }
     if(Stop1&&Stop2){
      clearInterval(maxTime);
      tagImg.appendChild(img);
	  tagImg.style.width=img.offsetWidth+"px"; ////
	  tagImg.style.left=((sx-img.offsetWidth)/2)+"px";
      temp=0;
      imgOPacity();
     }
    },1);
    function imgOPacity(){
     temp+=10;
     img.style.filter="alpha(opacity="+temp+")";
     img.style.opacity=temp/100;
     imgTime=setTimeout(imgOPacity,1)
     if(temp>100) clearTimeout(imgTime);
    }
    tagImg.innerHTML="";
    tagImg.appendChild(closeTag);
    if(ix>xx||iy>yy){
     img.alt="左键拖动,双击放大缩小";
	 img.title="左键拖动,双击放大缩小";
     img.ondblclick=function (){
      if(tagImg.offsetWidth<img.offsetWidth||tagImg.offsetHeight<img.offsetHeight){
       img.style.width="auto";
       img.style.height="100%";
       img.alt="双击可以放大";
       img.onmousedown=null;
       closeTag.style.top="10px";
       closeTag.style.left="10px";
       tagImg.style.overflow="visible";
       tagImg.style.width=img.offsetWidth+"px";
       tagImg.style.left=((sx-img.offsetWidth)/2)+"px";
      }else{
       img.style.width=ix+"px";
       img.style.height=iy+"px";
       img.alt="双击可以缩小";
       img.onmousedown=dragDown;
       tagImg.style.overflow="auto";
       tagImg.style.width=xx+"px";
       tagImg.style.left=((sx-xx)/2)+"px";
      }
     }
     img.onmousedown=dragDown;
     tagImg.onmousemove=barHidden;
     tagImg.onmouseout=moveStop;
     document.onmouseup=moveStop;
    }else{
     tagImg.style.overflow="visible";
     tagImg.onmousemove=barHidden;
    }
	////图片过大时
	   if(wi){
		   img.style.width="auto";
		   img.style.height="100%";
		   img.alt="双击可以放大";
		   img.onmousedown=null;
		   tagImg.style.overflow="visible";
		   tagImg.style.height=img.offsetHeight+"px";
		}
   }
   function dragDown(a){
    img.style.cursor="pointer";
    var evts=a||window.event;
    var onx=evts.clientX,ony=evts.clientY;
    var sox=tagImg.scrollLeft,soy=tagImg.scrollTop;
    var sow=img.width+2-tagImg.clientWidth,soh=img.height+2-tagImg.clientHeight;
    var xxleft,yytop;
    document.onmousemove=function(e){
     var evt=e||window.event;
     xxleft=sox-(evt.clientX-onx)<0?"0":sox-(evt.clientX-onx)>sow?sow:sox-(evt.clientX-onx);
     yytop=soy-(evt.clientY-ony)<0?"0":soy-(evt.clientY-ony)>soh?soh:soy-(evt.clientY-ony);
     tagImg.scrollTop=yytop;
     tagImg.scrollLeft=xxleft;
     closeTag.style.top=(yytop+10)+"px";
     closeTag.style.left=(xxleft+10)+"px";
     return false;
    }
    return false;
   }
   function barHidden(){
    clearTimeout(barShow);
    if(closeTag.style.display=="none")closeTag.style.display="block";
    barShow=setTimeout(function(){closeTag.style.display="none";},2000);
   }
   function closes(){
    document.body.removeChild(tag);
    document.body.removeChild(tagImg);
    clearTimeout(barShow);
    clearTimeout(imgTime);
    document.onmouseup=null;
    tag=img=tagImg=closeTag=null;
   }
   function moveStop(){
    document.onmousemove=null;
    tagImg.onmousemove=barHidden;
    img.style.cursor="default";
   }
   
}

function inputer_viewFile(e)
{
	var imgPre = $(e).prev().children("img").eq(0).get(0);
	var imgNext = $(e).next().children("img").eq(0).get(0);
	if(imgPre){
		viewImage(imgPre);
		return;
	}
	if(imgNext){
		viewImage(imgNext);
		return;
	}
	//var href = $(e).prev().eq(0).get(0);	

	var fieldvalue_id=$(e).attr('fieldvalue_id');
	var value=$("#"+fieldvalue_id).val();
	var filename=value;
	var savename=value;
	var arr=value.split('~');
	if (arr.length>1)
	{
		filename=arr[0];
		savename=arr[1];
	}
	var filepath =g_rooturl+"/Public/uploadfile/"; 	
	viewOfficeDoc(filepath+savename);
}

//打开office文档预览页面
function viewOfficeDoc(url)
{
	var pos=url.lastIndexOf(".");
	var ext=url.substring(pos+1);
 	var url=openOffice(url,ext);
	if (!url)
		mcdom.popup('无法预览此文件',{fateOut:true,position:'middle',fadeOut:true});
	else
		mcdom.showIframe(url,{width:'800px',height:'600px',openNewWindow:true});
}

//计算一条记录的表达式
function uni_calculateOneRecord(fields,record)
{
	for(var i=0;i<fields.length;i++)
	{
		if (fields[i].type=='calculated')
		{
			var v=fields[i].data;
			if (v)
			{
				for (var k=0;k<fields.length;k++)
				{ 		
					var val = record[fields[k].id];	
					v=uni_calculate_replace(v,fields[k],val);			
				}
				try{
					record[fields[i].id]='';
					v = v.replace(/--/gi,"+");
					v=eval(v);
					if (!isNaN(v))
						v=Math.round(v*100)/100;
					record[fields[i].id]=v;
				}
				catch(e){
					//暂时不提示
				}
			}
		}
	}
	return record;
}

//一维数组复制
function uni_copyJSON(json)
{
	var json2={};
	for(var k in json)
		json2[k]=json[k];
	return json2;
}

//计算一条记录的表达式 sssss
function uni_calculate_replace(v,field,val)
{
	if (field.type=="numtext" || field.type=="float" || field.type=="int" || field.fieldtype=="float" || field.fieldtype=="int")
	{
		if (v.indexOf("[")==-1){
			var reg = new RegExp(field.id,"gi");
			v = v.replace(reg,val==null?0:val);
		}else{
			var reg = new RegExp("\\["+field.id+"\\]","gi");
			v = v.replace(reg,val==null?0:val);
		}
	}
	else
	if (!field.type || field.type=="text") 
	{
		if (v.indexOf("[")==-1){
			var reg = new RegExp(field.id,"gi");
			v = v.replace(reg,val==null?"":val);
		}else{
			var reg = new RegExp("\\["+field.id+"\\]","gi");
			v = v.replace(reg,val==null?"":val);
		}
	}
	return v;
}

